#include <mytypes.h>
#include "urlpass.h"
#include "filefunc.h"
#include "dman.h"

 Boolean cfgTestExists(void){
 FileHand testExists;

 testExists=FileOpen(cardNoDef, flCfgName,typeFConf, appCreator, 
  fileModeReadOnly, &fsErrApp);
 if(fsErrApp==errNone){
  FileClose(testExists);
  return true;
 }
 return false;
}

//$ % ' - _ @ ~ ! ( ) ^ # & + , ; = [ ] . `      A-Z,a-z,0-9 valid VFS
//* + , . / : ; < = > ? [ ] | \ ^ "             non-valid for Database
// "_" used to escape non valid

 void vfsFsEncodeName(MemPtr p2Use, UInt16 len2Prcss){
 UInt16 cInc;

 if(len2Prcss==0)
  return;
 for(cInc=0;cInc<len2Prcss;cInc++){
  if((*(Char *)p2Use>='a'&&*(Char *)p2Use<='z')
   ||(*(Char *)p2Use>='A'&&*(Char *)p2Use<='Z')
   ||(*(Char *)p2Use>='0'&&*(Char *)p2Use<='9')){
   p2Use=(MemPtr)((UInt32)p2Use+1);
  }else{
   switch(*(Char *)p2Use){
    case '$':
    case '%':
    case '\'':
    case '-':
    case '_':
    case '@':
    case '~':
    case '!':
    case '(':
    case ')':
    case '^':
    case '#':
    case '&':
    case '+':
    case ',':
    case ';':
    case '=':
    case '[':
    case ']':
    case '.':
    case '`':
     p2Use=(MemPtr)((UInt32)p2Use+1);
     break;
    default:
    *(Char *)p2Use='_';
     p2Use=(MemPtr)((UInt32)p2Use+1);    
   }
  }
 }
}

 void vfsFsSetPos(void){
 if((flsStatus&flsMaskCntnCmd)==0||(flsStatus&flsMaskOpCrFile)==0)
  return;
 tstFlsStatus=flsStatus&flsMaskMemVfsFs;
 if(tstFlsStatus==flsMaskMemVfs){
  fsErrApp=VFSFileSeek(fsVfsDataFilePtr->destRef.flR2Write2, vfsOriginBeginning,fsVfsDataFilePtr->rcvdDataLen);
  if(fsErrApp!=errNone){
   errBufferPreSet(idvfsFsSetPos,1,errTypeOfErrOutput|errTypeOfErrCritical);
   errBufferSetErr(errFlsVfsSeekFailed,fsErrApp);
   errBufferSetParam(paramTypeFlsOper,fsVfsDataFilePtr->rcvdDataLen,0,0,0);
   errBufferPush();
   flsStatus|=flsMaskErr;
  }
 }
 if(tstFlsStatus==flsMaskMemFs){
  fsErrApp=FileSeek(fsVfsDataFilePtr->destRef.flH2Write2,fsVfsDataFilePtr->rcvdDataLen,fileOriginBeginning);
  if(fsErrApp!=errNone){
   errBufferPreSet(idvfsFsSetPos,2,errTypeOfErrOutput|errTypeOfErrCritical);
   errBufferSetErr(errFlsFsSeekFailed,fsErrApp);
   errBufferSetParam(paramTypeFlsOper,fsVfsDataFilePtr->rcvdDataLen,0,0,0);
   errBufferPush();
   flsStatus|=flsMaskErr;
  }
 }
 setFileDwnldNrm();
}

 Boolean setDefPath(urlInfoDataPtr urlData){
 UInt32 id4DefPath;str4NameType fNameStr,fPathStr;
 Boolean rspOK=false,vfsEnabled=false;
 
 if(!cstmMemoryGet(cstmMemTypeOfChnkHandleLocked,pathChunkSize,idsetDefPath,1))
  return rspOK;
 else{
  id4DefPath=cstmMemTableDman.chnkDataRelative->uniqueID;
  fPathStr.strNamePtr=cstmMemTableDman.chnkDataRelative->newPtrConst;
  if(urlData->flNameLen!=NULL){
   fNameStr.strNamePtr=urlData->filePtr;
   fNameStr.strLen=urlData->flNameLen;
  }else{
   fNameStr.strNamePtr=flNUndef;
   fNameStr.strLen=10;
  }
  if(vfsFsCrtPath(&fPathStr,&fNameStr,vfsEnabled))
   rspOK=true;
  cstmMemoryDrop(id4DefPath);
 }
 return rspOK;
}

 void setFileDwnldNrm(void){

 flsStatus&=(flsMaskAllSet^(flsMaskChnksDwnld));
 flsStatus|=flsMaskDwnlNrm;
}

 void setFileChnksDwnld(void){

 flsStatus&=(flsMaskAllSet^(flsMaskChnksDwnld));
 flsStatus|=flsMaskChnksDwnld;
}

 void setFileCntnCmd(void){

 flsStatus&=(flsMaskAllSet^(flsMaskChnksDwnld));
 flsStatus|=flsMaskCntnCmd;
}

 void setDel(void){

 flsStatus&=(flsMaskAllSet^(flsMaskMove));
 flsStatus|=flsMaskDel;
}

 void setNormal(void){

 flsStatus&=(flsMaskAllSet^(flsMaskMove));
}

 void setMove(void){

 flsStatus&=(flsMaskAllSet^(flsMaskMove));
 flsStatus|=(flsMaskMove);
}

 void setStop(void){

 flsStatus&=(flsMaskAllSet^(flsMaskMove));
 flsStatus|=flsMaskStop;
}

 void setFlsDscr(UInt16 httpDscrCopy, UInt32 lenData){

 if((httpDscrCopy&1)==0)
  return;
 fsVfsDataFilePtr->fullDataLen=lenData;
 flsDscr|=httpDscrCopy;
 if((flsRules&flsRulePreAlloc)!=0&&(flsDscr&4)!=0)
  flsStatus|=flsMaskPreAlloc;
}

 void writeFromBuffer(MemPtr wrtFrom, Int32 len2Write){//debugging
 Int32 wrtnLen;FileHand flHDebug;

 flHDebug=FileOpen(cardNoDef, flName31, typeFDef, appCreator, fileModeAppend,&fsErrApp);
 wrtnLen=FileWrite(flHDebug,wrtFrom,1, len2Write, &fsErrApp);
 fsErrApp=FileClose(flHDebug);
}

 void rszFile(UInt32 szRsz){

 if((flsStatus&flsMaskErr)!=0)
  return;
 if((flsRules&flsRuleChckFrSpace)!=0)
  if(!(vfsFsFreeSpace(szRsz,flsStatus&flsMaskMemVfsFs))){
   flsStatus|=flsMaskErr;
   return;
  }
 tstFlsStatus=flsStatus&(flsMaskMemVfs|flsMaskOpCrFile);
 if(fsVfsDataFilePtr->fullDataLen!=0){
  if(tstFlsStatus==(flsMaskMemVfs|flsMaskOpCrFile)){
   fsErrApp=VFSFileResize(fsVfsDataFilePtr->destRef.flR2Write2,fsVfsDataFilePtr->fullDataLen);
   if(fsErrApp!=0){
    errBufferPreSet(idrszFile,1,errTypeOfErrOutput|errTypeOfErrCritical);
    errBufferSetErr(errFlsVfsResizeFailed,fsErrApp);
    errBufferSetParam(paramTypeFlsOper,fsVfsDataFilePtr->fullDataLen,0,0,0);
    errBufferPush();
    flsStatus|=flsMaskErr;
   }
  }
 }else{
  if((flsDscr&9)==9){
   if(tstFlsStatus==(flsMaskMemVfs|flsMaskOpCrFile)){
    fsErrApp=VFSFileResize(fsVfsDataFilePtr->destRef.flR2Write2,fsVfsDataFilePtr->rcvdDataLen+szRsz);
    if(fsErrApp!=0){
     errBufferPreSet(idrszFile,2,errTypeOfErrOutput|errTypeOfErrCritical);
     errBufferSetErr(errFlsVfsResizeFailed,fsErrApp);
     errBufferSetParam(paramTypeFlsOper,fsVfsDataFilePtr->rcvdDataLen+szRsz,0,0,0);
     errBufferPush();
     flsStatus|=flsMaskErr;
    }
   }
  }
 }
}

 Boolean vfsFsWriteProc(MemPtr bufWrtFrm,UInt32 len2Write, UInt8 indxChnk){
 UInt32 nBWritten;Int32 skCalc;

 if((flsStatus&flsMaskErr)!=0)
  return false;
 if(len2Write==0)
  return true;
 if((flsStatus&flsMaskPreAlloc)==0){
  rszFile(len2Write);
 }
 if((flsStatus&flsMaskErr)!=0)
  return false;
 tstFlsStatus=flsStatus&(flsMaskChnksDwnld|flsMaskOpCrFile);//dwnl,cont,filecrt
 if(tstFlsStatus==(flsMaskDwnlNrm|flsMaskOpCrFile)){//writting normal
  tstFlsStatus=flsStatus&flsMaskMemVfsFs;
  if(tstFlsStatus==flsMaskMemVfs){
   fsErrApp=VFSFileWrite(fsVfsDataFilePtr->destRef.flR2Write2, len2Write,bufWrtFrm, &nBWritten);
  }
  if(tstFlsStatus==flsMaskMemFs){
   nBWritten=FileWrite(fsVfsDataFilePtr->destRef.flH2Write2,bufWrtFrm,1, len2Write, &fsErrApp);
  }
 }else
 if(tstFlsStatus==(flsMaskChnksDwnld|flsMaskOpCrFile)){//continue stoped chunked dwnl
  tstFlsStatus=flsStatus&flsMaskMemVfsFs;
  skCalc=fsVfsDataFilePtr->chnk0B[indxChnk]-fsVfsDataFilePtr->chnkBase;
  if(tstFlsStatus==flsMaskMemVfs){
   fsErrApp=VFSFileSeek(fsVfsDataFilePtr->destRef.flR2Write2, vfsOriginBeginning,fsVfsDataFilePtr->chnkBase);
   if(fsErrApp!=errNone){
    errBufferPreSet(idvfsFsWriteProc,2,errTypeOfErrOutput|errTypeOfErrCritical);
    errBufferSetErr(errFlsVfsSeekFailed,fsErrApp);
    errBufferSetParam(paramTypeFlsOper,fsVfsDataFilePtr->chnkBase,0,0,0);
    errBufferPush();
    flsStatus|=flsMaskErr;
    return false;
   }else{
    fsErrApp=VFSFileSeek(fsVfsDataFilePtr->destRef.flR2Write2, vfsOriginCurrent,skCalc);
    if(fsErrApp!=errNone){
     errBufferPreSet(idvfsFsWriteProc,3,errTypeOfErrOutput|errTypeOfErrCritical);
     errBufferSetErr(errFlsVfsSeekFailed,fsErrApp);
     errBufferSetParam(paramTypeFlsOper,skCalc,0,0,0);
     errBufferPush();
     flsStatus|=flsMaskErr;
     return false;
    }else{
     fsErrApp=VFSFileWrite(fsVfsDataFilePtr->destRef.flR2Write2, len2Write,bufWrtFrm, &nBWritten);
    }
   }
  }
  if(tstFlsStatus==flsMaskMemFs){
   fsErrApp=FileSeek(fsVfsDataFilePtr->destRef.flH2Write2,fsVfsDataFilePtr->chnkBase,fileOriginBeginning);
   if(fsErrApp!=errNone){
     errBufferPreSet(idvfsFsWriteProc,4,errTypeOfErrOutput|errTypeOfErrCritical);
     errBufferSetErr(errFlsFsSeekFailed,fsErrApp);
     errBufferSetParam(paramTypeFlsOper,fsVfsDataFilePtr->chnkBase,0,0,0);
     errBufferPush();
     flsStatus|=flsMaskErr;
     return false;
    }else{
     fsErrApp=FileSeek(fsVfsDataFilePtr->destRef.flH2Write2,skCalc,fileOriginCurrent);
     if(fsErrApp!=errNone){
      errBufferPreSet(idvfsFsWriteProc,5,errTypeOfErrOutput|errTypeOfErrCritical);
      errBufferSetErr(errFlsFsSeekFailed,fsErrApp);
      errBufferSetParam(paramTypeFlsOper,skCalc,0,0,0);
      errBufferPush();
      flsStatus|=flsMaskErr;
      return false;
     }else{
      nBWritten=FileWrite(fsVfsDataFilePtr->destRef.flH2Write2,bufWrtFrm,1, len2Write, &fsErrApp);
     }
    }
  }
 }
 if(nBWritten==len2Write){
  fsVfsDataFilePtr->rcvdDataLen+=nBWritten;
  fsVfsDataFilePtr->chnk0B[indxChnk]+=nBWritten;
 }else{
  errBufferPreSet(idvfsFsWriteProc,1,errTypeOfErrOutput|errTypeOfErrCritical);
  errBufferSetErr(errFlsWriteFailed,fsErrApp);
  errBufferSetParam(paramTypeFlsOper,len2Write,nBWritten,0,0);
  errBufferPush();
  flsStatus|=flsMaskErr;
  return false;
 }
 return true;
}

 UInt8 vfsInit(void){
 UInt32 vfsMgrVer;UInt8 inc4Cnt=0;
 UInt32 volIterator=vfsIteratorStart; 
 
 fsErrApp=FtrGet(sysFileCVFSMgr, vfsFtrIDVersion, &vfsMgrVer); 
 if(fsErrApp){
  noVfsAvlbl=true;
 }else{
  noVfsAvlbl=false;
  while((volIterator!=vfsIteratorStop)&&inc4Cnt<4) {
   fsErrApp=VFSVolumeEnumerate(&volRefApp, &volIterator);
   if(fsErrApp==errNone){
    volRefLst[inc4Cnt]=volRefApp;
    inc4Cnt++;
   }else{
    volIterator=vfsIteratorStop;
   } 
  }
 }
 numDir=0;
 volRefLst[5]=0;
 return inc4Cnt;
}

 Boolean vfsFsCheckExists(void){
 Boolean rspOK=true;

 if(vfsFsContainerExists(0)==1){
  switch((flsRules&(flsRuleExists))){
   case flsRuleARenExists:
    if(!(gnrtNameEnd()))
     rspOK=false;
    break;
   case flsRuleDelExists:
    if(vfsFsContainerExists(flsRules&(flsRuleExists))!=3)
     rspOK=false;
    break;
   case flsRuleNone:
    if((flsStatus&flsMaskCntnCmd)==0)
     rspOK=false;
    break;
  }
 }
 return rspOK;
}

 void vfsFsChngName(str4NamePtr basicName){
 UInt32 cmpPdb;

 tstFlsStatus&=flsMaskMemVfsFs;
 if(tstFlsStatus==flsMaskMemVfs){
  MemMove((MemPtr)((UInt32)(path4CmnUse.strNamePtr)+(UInt32)(fsVfsDataFilePtr->offstName)),
   basicName->strNamePtr,basicName->strLen+1);
  path4CmnUse.strLen=fsVfsDataFilePtr->offstName+basicName->strLen;
  fsVfsDataFilePtr->flNmLen=path4CmnUse.strLen;
  vfsFsEncodeName((MemPtr)((UInt32)(path4CmnUse.strNamePtr)+(UInt32)(fsVfsDataFilePtr->offstName)),basicName->strLen);
 }
 if(tstFlsStatus==flsMaskMemFs){
  MemMove(name4ViewUse.strNamePtr,basicName->strNamePtr,basicName->strLen+1);
  name4ViewUse.strLen=basicName->strLen;
  if((flsCstm&1)!=0){
   flsStatus&=(flsMaskAllSet^flsMaskPreprcss);
   flsCstm&=254;
  }
  if(basicName->strLen>4){
   cmpPdb=*((Char *)((UInt32)(basicName->strNamePtr)+(UInt32)(basicName->strLen)-4));
   cmpPdb=cmpPdb<<8;
   cmpPdb|=*((Char *)((UInt32)(basicName->strNamePtr)+(UInt32)(basicName->strLen)-3));
   cmpPdb=cmpPdb<<8;
   cmpPdb|=*((Char *)((UInt32)(basicName->strNamePtr)+(UInt32)(basicName->strLen)-2));
   cmpPdb=cmpPdb<<8;
   cmpPdb|=*((Char *)((UInt32)(basicName->strNamePtr)+(UInt32)(basicName->strLen)-1));
   if(cmpPdb=='.prc'||cmpPdb=='.pdb'){
    flsStatus|=flsMaskPreprcss;
    flsCstm|=1;
   }
  }
  if((flsCstm&1)==0){
   MemMove(path4CmnUse.strNamePtr,basicName->strNamePtr,basicName->strLen);
   path4CmnUse.strLen=basicName->strLen;
  }else{
   MemMove(path4CmnUse.strNamePtr,ftName31,8);
   path4CmnUse.strLen=8;
  }
  fsVfsDataFilePtr->flNmLen=path4CmnUse.strLen;
  vfsFsEncodeName((MemPtr)((UInt32)(path4CmnUse.strNamePtr)+(UInt32)(fsVfsDataFilePtr->offstName)),path4CmnUse.strLen);
 }
 if(!vfsFsCheckExists)
  flsStatus|=flsMaskErr;
}

 Boolean gnrtNameEnd(void){
 UInt8 iNameEnd=1,szNameEnd, szAllName, szExt=0;
 Boolean rspOK=false,extIs;MemPtr strtName, str4GnrtNameEnd;
 UInt32 id4gnrtNameEnd;

 tstFlsStatus=flsStatus&flsMaskMemVfsFs;
 strtName=(MemPtr)((UInt32)path4CmnUse.strNamePtr+(UInt32)fsVfsDataFilePtr->offstName);
 if(cstmMemoryGet(cstmMemTypeOfChnkHandleLocked,nameChunkSize, idgnrtNameEnd,1)){
  id4gnrtNameEnd=cstmMemTableDman.chnkDataRelative->uniqueID;
  str4GnrtNameEnd=cstmMemTableDman.chnkDataRelative->newPtrConst;
 }else
   return rspOK;
 szAllName=fsVfsDataFilePtr->flNmLen;
 szExt=szAllName;
 do{
  szNameEnd=*((Char *)((UInt32)strtName+(UInt32)szExt));
  szExt--;
 }while(szNameEnd!=cDot&&szExt!=0);
 szExt++;
 szExt=szAllName-szExt;
 if(szNameEnd==cDot){
  MemSet(str4GnrtNameEnd,nameChunkSize,NULL);
  if(szExt>252)
   szExt=252;
  MemMove(str4GnrtNameEnd, (MemPtr)((UInt32)strtName
   +(UInt32)(fsVfsDataFilePtr->flNmLen-szExt)),szExt+1);
  extIs=true;
 }else
  extIs=false;
 if(tstFlsStatus==flsMaskMemVfs&&path4CmnUse.strLen>4346)
  szAllName-=4;
 if(tstFlsStatus==flsMaskMemFs&&path4CmnUse.strLen>27)
  szAllName-=4;
 if(extIs)
  szAllName-=szExt;
 strtName=(MemPtr)((UInt32)strtName+(UInt32)szAllName);
 MemSet(strtName,1,'(');
 strtName+=1;
 szAllName++;
 do{
  szNameEnd=int2Str(iNameEnd,strtName);
  MemSet(strtName+szNameEnd,1,')');
  szNameEnd++;
  MemSet(strtName+szNameEnd,1,NULL);
  if(extIs){
   MemMove(strtName+szNameEnd,str4GnrtNameEnd,szExt+1);
   szNameEnd+=szExt;
  }
  if(vfsFsContainerExists(0)==0){
   szAllName+=szNameEnd;
   path4CmnUse.strLen=szAllName+fsVfsDataFilePtr->offstName;
   fsVfsDataFilePtr->flNmLen=szAllName;
   rspOK=true;
  }
  iNameEnd++;
 }while(iNameEnd!=100&&!rspOK);
 cstmMemoryDrop(id4gnrtNameEnd);
 return rspOK;
}

 void rstVolRefApp(void){
 if(volRefLst[4]!=0){
  volRefApp=volRefLst[4];
  volRefLst[4]=0;
 }
}

 void setVolRefApp(UInt8 indxVfs){
 volRefLst[4]=volRefApp;
 volRefApp=volRefLst[indxVfs];
}

 void vfsFsSetPathVar(str4NameType path2Set, MemPtr pPath2Set, Int16 lPath2Set){
 if(pPath2Set!=0){
  path4CmnUse.strNamePtr=pPath2Set;
  path4CmnUse.strLen=lPath2Set;
 }else
  path4CmnUse=path2Set;
}//????

 Boolean vfsFsCrtPath(str4NamePtr basicLoc,str4NamePtr basicName, Boolean isItVfs){
 UInt32 cmpPdb;

 if(basicName->strLen==0)
  return false;
 if(isItVfs){
   if(cstmMemoryGet(cstmMemTypeOfChnkHandleLocked,(pathChunkSize+(nameChunkSize*2)),idvfsCrtPath,1)){
    flsStatus|=flsMaskMemVfs;
    path4CmnUse.strNamePtr=cstmMemTableDman.chnkDataRelative->newPtrConst;
    fsVfsDataFilePtr->id4Mem4PathName=cstmMemTableDman.chnkDataRelative->uniqueID;
    MemSet(path4CmnUse.strNamePtr,(pathChunkSize+(nameChunkSize*2)),NULL);
    name4ViewUse.strNamePtr=(MemPtr)((UInt32)path4CmnUse.strNamePtr+(pathChunkSize+nameChunkSize));
    MemMove(path4CmnUse.strNamePtr,basicLoc->strNamePtr,basicLoc->strLen);
    path4CmnUse.strLen=basicLoc->strLen;
    MemMove((MemPtr)((UInt32)(path4CmnUse.strNamePtr)+(UInt32)(basicLoc->strLen)),
     basicName->strNamePtr,basicName->strLen);
    fsVfsDataFilePtr->offstName=basicLoc->strLen;
    path4CmnUse.strLen+=basicName->strLen;
    fsVfsDataFilePtr->flNmLen=basicName->strLen;
    vfsFsEncodeName((MemPtr)((UInt32)(path4CmnUse.strNamePtr)+(UInt32)(basicLoc->strLen)),basicName->strLen);
    MemMove(name4ViewUse.strNamePtr,basicName->strNamePtr,basicName->strLen);
    name4ViewUse.strLen=basicName->strLen;
   }
 }else{
  if(cstmMemoryGet(cstmMemTypeOfChnkHandleLocked,(nameChunkSize*2),idvfsCrtPath,2)){
   flsStatus|=flsMaskMemFs;
   path4CmnUse.strNamePtr=cstmMemTableDman.chnkDataRelative->newPtrConst;
   fsVfsDataFilePtr->id4Mem4PathName=cstmMemTableDman.chnkDataRelative->uniqueID;
   MemSet(path4CmnUse.strNamePtr,(nameChunkSize*2),NULL);
   name4ViewUse.strNamePtr=(MemPtr)((UInt32)path4CmnUse.strNamePtr+nameChunkSize);
   if(basicName->strLen>4){
    cmpPdb=*((Char *)((UInt32)(basicName->strNamePtr)+(UInt32)(basicName->strLen)-4));
    cmpPdb=cmpPdb<<8;
    cmpPdb|=*((Char *)((UInt32)(basicName->strNamePtr)+(UInt32)(basicName->strLen)-3));
    cmpPdb=cmpPdb<<8;
    cmpPdb|=*((Char *)((UInt32)(basicName->strNamePtr)+(UInt32)(basicName->strLen)-2));
    cmpPdb=cmpPdb<<8;
    cmpPdb|=*((Char *)((UInt32)(basicName->strNamePtr)+(UInt32)(basicName->strLen)-1));
    if(cmpPdb=='.prc'||cmpPdb=='.pdb'){
     flsStatus|=flsMaskPreprcss;
     flsCstm|=1;
    }
   }
   if((flsCstm&1)==0){
    MemMove(path4CmnUse.strNamePtr,basicName->strNamePtr,basicName->strLen);
    path4CmnUse.strLen=basicName->strLen;
   }else{
    MemMove(path4CmnUse.strNamePtr,ftName31,9);
    path4CmnUse.strLen=8;
   }
   MemMove(name4ViewUse.strNamePtr,basicName->strNamePtr,basicName->strLen);
   name4ViewUse.strLen=basicName->strLen;
   vfsFsEncodeName(path4CmnUse.strNamePtr,path4CmnUse.strLen);
   fsVfsDataFilePtr->offstName=NULL;
   fsVfsDataFilePtr->flNmLen=path4CmnUse.strLen;
  }
 }
 if((flsStatus&flsMaskMemVfsFs)!=0){
  cmpPdb=vfsFsCheckExists();
 }else{
  cmpPdb=false;
 }
 if(!cmpPdb){
  flsStatus|=flsMaskErr;
  errBufferPreSet(idvfsCrtPath,3,errTypeOfErrMemory|errTypeOfErrCritical);
  errBufferSetErr(errFlsPathNameFailed,0);
  errBufferPush();
 }
 return cmpPdb;
}

 Boolean vfsFsFreeSpace(UInt32 neededSize, UInt8 mask){
 UInt32 rcvdSize, freeSize=0;Boolean rspOK=false;

 if((mask&flsMaskMemVfsFs)==flsMaskMemVfs){
  fsErrApp=VFSVolumeSize(volRefApp,&rcvdSize,&freeSize);//!!!err
  freeSize-=rcvdSize;
 }
 if((mask&flsMaskMemVfsFs)==flsMaskMemFs){
  fsErrApp=MemHeapFreeBytes(heapIDStorage,&freeSize,&rcvdSize);//!!!err
 }
 if(freeSize>32767&&dSpaceFree>32767&&freeSize>dSpaceFree){
  freeSize-=dSpaceFree;
  if(freeSize>=neededSize)
   rspOK=true;
 }
 return rspOK;
}

 UInt8 vfsFsContainerExists(UInt8 mtdInUse){
 //mtdInUse, 0b-delete if exist, 1b-generate new name
 UInt8 rspOK=0;
 //rspOK, 0b-container found, 1b - action done(0-failed,1-OK)

 tstFlsStatus=flsStatus&(flsMaskMemVfsFsErr);
 if(tstFlsStatus==flsMaskMemVfs){
  fsErrApp=VFSFileOpen(volRefApp, path4CmnUse.strNamePtr,
   vfsModeRead, &fsVfsDataFilePtr->destRef.flR2Write2);
  if(fsErrApp==errNone){
   fsErrApp=VFSFileClose(fsVfsDataFilePtr->destRef.flR2Write2);
   rspOK|=1;
   fsVfsDataFilePtr->destRef.flR2Write2=NULL;
   if((mtdInUse&1)!=0){
    fsErrApp=VFSFileDelete(volRefApp,path4CmnUse.strNamePtr);
    if(fsErrApp==errNone)
     rspOK|=2;
   }
   if((mtdInUse&2)!=0){
    if(gnrtNameEnd())
     rspOK|=2;
   }
  }else{
   if((mtdInUse&2)!=0){
    if(fsErrApp==vfsErrFilePermissionDenied)
     if(gnrtNameEnd())
      rspOK|=2;
    if(fsErrApp==vfsErrFileNotFound)
      rspOK|=2;
   }
  }
 }
 if(tstFlsStatus==flsMaskMemFs){
  if((flsStatus&flsMaskPreprcss)!=0&&(flsCstm&1)!=0)
   fsVfsDataFilePtr->destRef.flH2Write2=FileOpen(cardNoDef, path4CmnUse.strNamePtr,
    typeFTDef, appCreator, fileModeReadOnly, &fsErrApp);
  else
   fsVfsDataFilePtr->destRef.flH2Write2=FileOpen(cardNoDef, path4CmnUse.strNamePtr,
    typeFDef, appCreator, fileModeReadOnly, &fsErrApp);
  if(fsErrApp==errNone){
   fsErrApp=FileClose(fsVfsDataFilePtr->destRef.flH2Write2);
   rspOK|=1;
   fsVfsDataFilePtr->destRef.flH2Write2=NULL;
   if((mtdInUse&1)!=0){
    fsErrApp=FileDelete(cardNoDef,path4CmnUse.strNamePtr);
    if(fsErrApp==errNone)
     rspOK|=2;
   }
   if((mtdInUse&2)!=0){
    if(gnrtNameEnd())
     rspOK|=2;
   }
  }else{
   if((mtdInUse&2)!=0){
    if(fsErrApp==fileErrInUse)
     if(gnrtNameEnd())
      rspOK|=2;
    if(fsErrApp==fileErrNotFound)
     rspOK|=2;
   }
  }
 }
 if(mtdInUse!=0&&(rspOK&2)==0){
  errBufferPreSet(idvfsFsContainerExists,1,errTypeOfErrOutput|errTypeOfErrWarning);
  errBufferSetErr(errFlsExistCmdFailed,fsErrApp);
  errBufferSetParam(paramTypeFlsOper,mtdInUse,rspOK,0,0);
  errBufferPush();
 }
 return rspOK;
}

 Boolean vfsFsStartPoint(Boolean crtOrCntn){
 UInt32 mdOpen;

 if((flsStatus&flsMaskOpCrFile)!=0)
  return true;
 fsErrApp=errNone;
 tstFlsStatus=flsStatus&(flsMaskMemVfsFs);
 if(tstFlsStatus!=0&&crtOrCntn){
  vfsFsContainerExists(2);
 }
 if(tstFlsStatus==flsMaskMemVfs){
  if(crtOrCntn){
   fsErrApp=VFSFileCreate(volRefApp, path4CmnUse.strNamePtr);
  }
  if(fsErrApp==errNone){
   fsErrApp=VFSFileOpen(volRefApp, path4CmnUse.strNamePtr,
   vfsModeReadWrite, &fsVfsDataFilePtr->destRef.flR2Write2);
   if(fsErrApp==errNone){
    flsStatus|=flsMaskOpCrFile;
    if(crtOrCntn&&(flsStatus&flsMaskPreAlloc)!=0){
     fsErrApp=VFSFileResize(fsVfsDataFilePtr->destRef.flR2Write2,fsVfsDataFilePtr->fullDataLen);
     if(fsErrApp!=errNone){
      errBufferPreSet(idvfsFsStartPoint,3,errTypeOfErrOutput|errTypeOfErrCritical);
      errBufferSetErr(errFlsVfsResizeFailed,fsErrApp);
      errBufferSetParam(paramTypeFlsOper,fsVfsDataFilePtr->fullDataLen,0,0,0);
      errBufferPush();
      setDel();
      vfsFsEndPoint();
      flsStatus|=flsMaskErr;
     }
    }
    if((flsStatus&flsMaskErr)==0)
     fsErrApp=VFSFileSeek(fsVfsDataFilePtr->destRef.flR2Write2, vfsOriginBeginning,0);
   }else{
    errBufferPreSet(idvfsFsStartPoint,2,errTypeOfErrOutput|errTypeOfErrCritical);
    errBufferSetErr(errFlsVfsOpenFailed,fsErrApp);
    errBufferPush();
    flsStatus|=flsMaskErr;
   }
  }else{
   errBufferPreSet(idvfsFsStartPoint,1,errTypeOfErrOutput|errTypeOfErrCritical);
   errBufferSetErr(errFlsVfsCreateFailed,fsErrApp);
   errBufferPush();
   flsStatus|=flsMaskErr;
  }
 }
 if(tstFlsStatus==flsMaskMemFs){
  if(crtOrCntn){
   mdOpen=fileModeReadWrite;
  }else{
   mdOpen=fileModeUpdate;
  }
  if((flsStatus&flsMaskPreprcss)!=0){
   if((flsCstm&1)!=0)
    fsVfsDataFilePtr->destRef.flH2Write2=FileOpen(cardNoDef,path4CmnUse.strNamePtr,
     typeFTDef, appCreator, mdOpen,&fsErrApp);
  }else
   fsVfsDataFilePtr->destRef.flH2Write2=FileOpen(cardNoDef,path4CmnUse.strNamePtr,
    typeFDef, appCreator, mdOpen,&fsErrApp);
  if(fsErrApp==errNone){
   flsStatus|=flsMaskOpCrFile;
   if(crtOrCntn&&(flsStatus&flsMaskPreAlloc)!=0){
    fsErrApp=FileSeek(fsVfsDataFilePtr->destRef.flH2Write2,(fsVfsDataFilePtr->fullDataLen-1),fileOriginBeginning);
    if(fsErrApp!=errNone){
     errBufferPreSet(idvfsFsStartPoint,4,errTypeOfErrOutput|errTypeOfErrCritical);
     errBufferSetErr(errFlsFsResizeFailed,fsErrApp);
     errBufferPush();
     setDel();
     vfsFsEndPoint();
     flsStatus|=flsMaskErr;
    }
    if((flsStatus&flsMaskErr)==0)
     fsErrApp=FileSeek(fsVfsDataFilePtr->destRef.flH2Write2,0,fileOriginBeginning);
   }
  }else{
   errBufferPreSet(idvfsFsStartPoint,5,errTypeOfErrOutput|errTypeOfErrCritical);
   errBufferSetErr(errFlsFsOpenFailed,fsErrApp);
   errBufferSetErr(mdOpen,0);
   errBufferPush();
   flsStatus|=flsMaskErr;
  }
 }
 if((flsStatus&flsMaskOpCrFile)==0){
  flsStatus|=flsMaskErr;
  return false;
 }
 return true;
}

 Err fsReadProc(void *dataP, UInt32 *sizeP,void *userDataP){
 UInt32 rdBytes;UInt16 fsErrPrc=0;

 if(FileEOF(fsVfsDataFilePtr->destRef.flH2Write2)==0){
  rdBytes=FileRead((fsVfsDataFilePtr->destRef.flH2Write2),dataP,1,*sizeP,&fsErrPrc);
  if(fsErrPrc==fileErrEOF)
   fsErrPrc=0;
  *sizeP=rdBytes;
 }else
  *sizeP=0;
 return fsErrPrc;
}

 Boolean fsDelProc(const char *nameP,UInt16 version,UInt16 cardNo,LocalID dbID,void *userDataP){
 UInt16 fsErrPrc;Boolean rspOK;

 fsErrPrc=DmDeleteDatabase(cardNo,dbID);
 if(fsErrPrc==0)
  rspOK=true;
 else
  rspOK=false;
 return rspOK;
}

 Boolean fsDbExists(Char *db2Srch){
  if(DmFindDatabase(cardNoDef,db2Srch)!=0)
   return true;
  return false;
 }

 Boolean fsDbGnrt(void){
 UInt16 fsErrPrc;Boolean rspOK; LocalID dbID;
 UInt8 dbNameLen,lNewName,dbNameEnd=1;MemPtr dbNamePtr,dbNewNamePtr;
 UInt32 sz2Use,id4fsDelProc;

 if(cstmMemoryGet(cstmMemTypeOfChnkHandleLocked,32,idfsDbGnrt,1)){
  dbNamePtr=cstmMemTableDman.chnkDataRelative->newPtrConst;
  id4fsDelProc=cstmMemTableDman.chnkDataRelative->uniqueID;
 }else
  return false;
 sz2Use=FileRead(fsVfsDataFilePtr->destRef.flH2Write2,dbNamePtr,1,32,&fsErrPrc);
 if(!(fsDbExists(dbNamePtr))){
  cstmMemoryDrop(id4fsDelProc);
  return true;
 }
 dbNameLen=StrLen(dbNamePtr);
 if(dbNameLen>27)
  dbNameLen=27;
 fsErrPrc=MemSet(dbNamePtr+dbNameLen,1,'(');
 dbNameLen++;
 fsErrPrc=MemSet(dbNamePtr+dbNameLen, 32-dbNameLen,NULL);
 dbNewNamePtr=(MemPtr)((UInt32)dbNamePtr+(UInt32)dbNameLen);
 do{
  lNewName=int2Str(dbNameEnd,dbNewNamePtr);
  fsErrPrc=MemSet(dbNewNamePtr+lNewName,1,')');
  lNewName++;
  fsErrPrc=MemSet(dbNewNamePtr+lNewName,32-dbNameLen-lNewName,NULL);
  dbID=DmFindDatabase(cardNoDef,dbNamePtr);
  dbNameEnd++;
 }while(dbNameEnd!=100&&dbID!=0);
 if(dbID==0){
  fsErrPrc=FileSeek(fsVfsDataFilePtr->destRef.flH2Write2,0,fileOriginBeginning);
  sz2Use=FileWrite(fsVfsDataFilePtr->destRef.flH2Write2,dbNamePtr,1, 32, &fsErrPrc);
  if(sz2Use==32)
   rspOK=true;
 }else{
  rspOK=false;
  errBufferPreSet(idfsDbGnrt,2,errTypeOfErrOutput|errTypeOfErrAlgoritm|errTypeOfErrCritical);
  errBufferSetErr(errFlsDbRenameFailed,0);
  errBufferPush();
 }
 cstmMemoryDrop(id4fsDelProc);
 return rspOK;
}

 void vfsFsEndPoint(void){
 LocalID dbIDApp;Boolean ndReset;

 if((flsStatus&(flsMaskMove))==0){
  tstFlsStatus=flsStatus&(flsMaskMemVfsFs|flsMaskOpCrFile);
  if(tstFlsStatus==(flsMaskMemVfs|flsMaskOpCrFile)){
   fsErrApp=VFSFileClose(fsVfsDataFilePtr->destRef.flR2Write2);
   if(fsErrApp==errNone){
    flsStatus&=(flsMaskAllSet^flsMaskOpCrFile);
   }else{
    errBufferPreSet(idvfsEndPoint,1,errTypeOfErrOutput|errTypeOfErrCritical);
    errBufferSetErr(errFlsVfsCloseFailed,fsErrApp);
    errBufferPush();
   }
  }
  if(tstFlsStatus==(flsMaskMemFs|flsMaskOpCrFile)){
   if((flsStatus&flsMaskPreprcss)==0){
    fsErrApp=FileClose(fsVfsDataFilePtr->destRef.flH2Write2);
    if(fsErrApp==errNone)
     flsStatus&=(flsMaskAllSet^flsMaskOpCrFile);
    else{
     errBufferPreSet(idvfsEndPoint,2,errTypeOfErrOutput|errTypeOfErrCritical);
     errBufferSetErr(errFlsFsCloseFailed,fsErrApp);
     errBufferPush();
    }
   }else{
    if((flsCstm&1)!=0){
     fsErrApp=FileSeek(fsVfsDataFilePtr->destRef.flH2Write2,0,fileOriginBeginning);
     if((flsRules&(flsRuleExists))==2){
      if(!(fsDbGnrt()))
       fsErrApp=1;
      else
       fsErrApp=FileSeek(fsVfsDataFilePtr->destRef.flH2Write2,0,fileOriginBeginning);
     }
     if(fsErrApp==0){
      fsErrApp=ExgDBRead(fsReadProc,fsDelProc,NULL,&dbIDApp,cardNoDef,&ndReset,false);
      if(fsErrApp==0){
       flsStatus&=(flsMaskAllSet^flsMaskPreprcss);flsCstm&=254;
      }else{
       errBufferPreSet(idvfsEndPoint,3,errTypeOfErrOutput|errTypeOfErrCritical);
       errBufferSetErr(errFlsDbConvFailed,fsErrApp);
       errBufferPush();
       flsStatus|=flsMaskErr;
      }
     }
     fsErrApp=FileClose(fsVfsDataFilePtr->destRef.flH2Write2);
     if(fsErrApp==errNone){
      flsStatus&=(flsMaskAllSet^flsMaskOpCrFile);
      fsErrApp=FileDelete(cardNoDef,path4CmnUse.strNamePtr);
      if(fsErrApp!=errNone){
       errBufferPreSet(idvfsEndPoint,5,errTypeOfErrOutput|errTypeOfErrCritical);
       errBufferSetErr(errFlsFsDelFailed,fsErrApp);
       errBufferPush();
      }
     }else{
      errBufferPreSet(idvfsEndPoint,4,errTypeOfErrOutput|errTypeOfErrCritical);
      errBufferSetErr(errFlsFsCloseFailed,fsErrApp);
      errBufferPush();
     }
    }
   }
  }
 }
 if((flsStatus&(flsMaskMove))==flsMaskDel){
  tstFlsStatus=flsStatus&(flsMaskMemVfsFs|flsMaskOpCrFile);
  if(tstFlsStatus==(flsMaskMemVfs|flsMaskOpCrFile)){
   fsErrApp=VFSFileClose(fsVfsDataFilePtr->destRef.flR2Write2);
   if(fsErrApp==errNone){
    fsErrApp=VFSFileDelete(volRefApp,path4CmnUse.strNamePtr);
    if(fsErrApp==errNone){
     flsStatus&=(flsMaskAllSet^(flsMaskOpCrFile|flsMaskDel));
    }else{
     errBufferPreSet(idvfsEndPoint,7,errTypeOfErrOutput|errTypeOfErrCritical);
     errBufferSetErr(errFlsVfsDelFailed,fsErrApp);
     errBufferPush();
    }
   }else{
    errBufferPreSet(idvfsEndPoint,6,errTypeOfErrOutput|errTypeOfErrCritical);
    errBufferSetErr(errFlsVfsCloseFailed,fsErrApp);
    errBufferPush();
   }
  }
  if(tstFlsStatus==(flsMaskMemFs|flsMaskOpCrFile)){
   if((flsStatus&flsMaskPreprcss)==0){
    fsErrApp=FileClose(fsVfsDataFilePtr->destRef.flH2Write2);
    if(fsErrApp==errNone){
     fsErrApp=FileDelete(cardNoDef,path4CmnUse.strNamePtr);
     if(fsErrApp==errNone){
      flsStatus&=(flsMaskAllSet^(flsMaskOpCrFile|flsMaskDel));
     }else{
      errBufferPreSet(idvfsEndPoint,9,errTypeOfErrOutput|errTypeOfErrCritical);
      errBufferSetErr(errFlsFsDelFailed,fsErrApp);
      errBufferPush();
     }
    }else{
     errBufferPreSet(idvfsEndPoint,8,errTypeOfErrOutput|errTypeOfErrCritical);
     errBufferSetErr(errFlsFsCloseFailed,fsErrApp);
     errBufferPush();
    }
   }else{
    if((flsCstm&1)!=0){
     fsErrApp=FileClose(fsVfsDataFilePtr->destRef.flH2Write2);
     if(fsErrApp==errNone){
      fsErrApp=FileDelete(cardNoDef,path4CmnUse.strNamePtr);
      if(fsErrApp==errNone){
       flsStatus&=(flsMaskAllSet^(flsMaskOpCrFile|flsMaskDel));
      }else{
       flsStatus&=(flsMaskAllSet^(flsMaskOpCrFile|flsMaskPreprcss|flsMaskMove));flsCstm&=254;
       errBufferPreSet(idvfsEndPoint,11,errTypeOfErrOutput|errTypeOfErrCritical);
       errBufferSetErr(errFlsFsDelFailed,fsErrApp);
       errBufferPush();
      }
     }else{
      errBufferPreSet(idvfsEndPoint,10,errTypeOfErrOutput|errTypeOfErrCritical);
      errBufferSetErr(errFlsFsCloseFailed,fsErrApp);
      errBufferPush();
     }
    }
   }
  }
 }
 if((flsStatus&(flsMaskMove))==flsMaskStop){
  tstFlsStatus=flsStatus&(flsMaskMemVfsFs|flsMaskOpCrFile);
  if(tstFlsStatus==(flsMaskMemVfs|flsMaskOpCrFile)){
   fsErrApp=VFSFileClose(fsVfsDataFilePtr->destRef.flR2Write2);
   if(fsErrApp!=errNone){
    errBufferPreSet(idvfsEndPoint,12,errTypeOfErrOutput|errTypeOfErrCritical);
    errBufferSetErr(errFlsVfsCloseFailed,fsErrApp);
    errBufferPush();
   }else{
    flsStatus&=(flsMaskAllSet^flsMaskOpCrFile);
   }
  }
  if(tstFlsStatus==(flsMaskMemFs|flsMaskOpCrFile)){
   fsErrApp=FileClose(fsVfsDataFilePtr->destRef.flH2Write2);
   if(fsErrApp!=errNone){
    errBufferPreSet(idvfsEndPoint,13,errTypeOfErrOutput|errTypeOfErrCritical);
    errBufferSetErr(errFlsFsCloseFailed,fsErrApp);
    errBufferPush();
   }else{
    flsStatus&=(flsMaskAllSet^flsMaskOpCrFile);
   }
  }
 }
}

 void clsAllVfsFs(void){

 vfsFsEndPoint();
 tstFlsStatus=flsStatus&flsMaskMemVfsFs;
 if(tstFlsStatus!=0){
  cstmMemoryDrop(fsVfsDataFilePtr->id4Mem4PathName);
  path4CmnUse.strNamePtr=NULL;
  fsVfsDataFilePtr->id4Mem4PathName=0;
  flsStatus&=(flsMaskAllSet^flsMaskMemVfsFs);
 }
}

 UInt32 lstSet4Bytes(Char *chars4,UInt8 num2Add){
 Char cFst;UInt32 numUsd,numOr;UInt8 shiftDec,pInc;
 
 numUsd=0;shiftDec=32;
 for(pInc=0;pInc<num2Add;pInc++){
  shiftDec-=8;
  cFst=*((Char*)((UInt32)chars4+(UInt32)pInc));
  if((cFst<0x5B)&&(cFst>0x40))
   cFst+=0x20;
  numOr=cFst;
  numOr=numOr<<shiftDec;
  numUsd|=numOr;
 }
 return numUsd;
}

 void lstSetup(void){
 
 id4Mem4Lst=0;
 if(cstmMemoryGet(cstmMemTypeOfChnkHandleLocked,dirBufferSz,idlstSetup,1)){
  lstPtrBase=cstmMemTableDman.chnkDataRelative->newPtrConst;
  id4Mem4Lst=cstmMemTableDman.chnkDataRelative->uniqueID;
 }
}

 void lstGet(UInt8 indxVol, Char *path2Browse){
 elmntType oneDir;
 elmntPtr setPtr,cmpPtr;
 FileInfoType dirInfo;
 UInt32 dirIterator,cmpFst,cmpSnd;
 FileRef dirRef;
 UInt8 calcInc,calcInit,bytesCmp,bytesMod,cmpLarge;
 Boolean cmpMade=true;

 numDir=0;
 volRefApp=volRefLst[indxVol];
 if(!(cstmMemoryUpdatePtr(id4Mem4Lst,&lstPtrBase)))
  return;
 MemSet(lstPtrBase,dirBufferSz,NULL);
 dirIterator=vfsIteratorStart;
 fsErrApp=VFSFileOpen(volRefApp, path2Browse, vfsModeRead, &dirRef);
 if(fsErrApp==errNone){
  while((dirIterator!=vfsIteratorStop)&&numDir!=200){
   setPtr=(MemPtr)((UInt32)lstPtrBase+(UInt32)(elmntSize*numDir));
   dirInfo.nameP=setPtr->elmnt;
   dirInfo.nameBufLen=256;
   fsErrApp=VFSDirEntryEnumerate(dirRef, &dirIterator, &dirInfo);
   if(dirInfo.attributes==vfsFileAttrDirectory&&fsErrApp==errNone){
    setPtr->elmntLen=StrLen(setPtr->elmnt);
    numDir++;
   }
  }
  fsErrApp=VFSFileClose(dirRef);
  if(fsErrApp!=errNone){
   errBufferPreSet(idlstGet,2,errTypeOfErrInput|errTypeOfErrCritical);
   errBufferSetErr(errFlsVfsCloseFailed,fsErrApp);
   errBufferPush();
  }
 }else{
  errBufferPreSet(idlstGet,1,errTypeOfErrInput|errTypeOfErrCritical);
  errBufferSetErr(errFlsVfsOpenFailed,fsErrApp);
  errBufferPush();
 }
 if(fsErrApp==errNone){
  calcInit=numDir-1;
  if(numDir>1){
   while(cmpMade){
    cmpMade=false;
    for(calcInc=0;calcInc<calcInit;calcInc++){
     setPtr=(MemPtr)((UInt32)lstPtrBase+(UInt32)(elmntSize*calcInc));
     cmpPtr=(MemPtr)((UInt32)lstPtrBase+(UInt32)(elmntSize*(calcInc+1)));
     if(setPtr->elmntLen>cmpPtr->elmntLen)
      bytesCmp=cmpPtr->elmntLen;
     else
      bytesCmp=setPtr->elmntLen;
     bytesMod=bytesCmp%2;
     if(bytesCmp>3)
      bytesCmp=bytesCmp>>2;
     cmpLarge=0;
     if(bytesCmp>0)
      for(cmpLarge=0;cmpLarge<bytesCmp;cmpLarge++){
       if(bytesCmp<4){
        cmpFst=lstSet4Bytes(setPtr->elmnt,bytesCmp);
        cmpSnd=lstSet4Bytes(cmpPtr->elmnt,bytesCmp);
       }else{
        cmpFst=lstSet4Bytes((MemPtr)((UInt32)(setPtr->elmnt)+(UInt32)(cmpLarge*4)),4);
        cmpSnd=lstSet4Bytes((MemPtr)((UInt32)(cmpPtr->elmnt)+(UInt32)(cmpLarge*4)),4);
       }
       if(cmpFst>cmpSnd){
        cmpFst=2;cmpLarge=bytesCmp;
       }else{
        if(cmpFst<cmpSnd){
         cmpFst=1;cmpLarge=bytesCmp;
        }else
         cmpFst=0;
       }
      }
     if(cmpFst==0){
      cmpFst=lstSet4Bytes((MemPtr)((UInt32)(setPtr->elmnt)+(UInt32)(cmpLarge*4)),bytesMod);
      cmpSnd=lstSet4Bytes((MemPtr)((UInt32)(cmpPtr->elmnt)+(UInt32)(cmpLarge*4)),bytesMod);
      if(cmpFst>cmpSnd){
       cmpFst=2;cmpLarge=bytesCmp;
      }else{
       if(cmpFst<cmpSnd){
        cmpFst=1;cmpLarge=bytesCmp;
       }else
        cmpFst=0;
      }
     }
     if(cmpFst==2){
      oneDir=*setPtr;
      *setPtr=*cmpPtr;
      *cmpPtr=oneDir;
      cmpMade=true;
     }
    }
    calcInit--;
   }
  }
 }
}

 void lstFree(void){
 if(id4Mem4Lst!=0)
  cstmMemoryDrop(id4Mem4Lst);
}

//error messages

 void msgInit(void){
 DmSearchStateType sState;UInt16 crdNo;LocalID dbID;Char *pMsg;
 Char verErrMsg[5]="0001";

 msgStt=0;
 cmdErr|=4;
 fsErrApp=DmGetNextDatabaseByTypeCreator(true,&sState,'appl',appCreator,true,&crdNo,&dbID);
 if(fsErrApp!=errNone){
  return;
 }
 dbErrMsg=DmOpenDatabase(crdNo,dbID,dmModeReadOnly);
 if(dbErrMsg==0)
  return;
 msgStt|=1;
 hErrMsg=DmGetResourceIndex(dbErrMsg,DmFindResource(dbErrMsg,'tSTL',rsrcErrMsg,0));
 if(hErrMsg==0)
  return;
 msgStt|=2;
 pMsg=MemHandleLock(hErrMsg);
 msgStt|=4;
 for(crdNo=0;crdNo<4;crdNo++){
  if(*((Char *)((UInt32)pMsg+(UInt32)crdNo))!=verErrMsg[crdNo])
   msgStt&=251;
 }
 MemHandleUnlock(hErrMsg);
 if((msgStt&4)==0)
  return;
 hHttpRspMsg=DmGetResourceIndex(dbErrMsg,DmFindResource(dbErrMsg,'tSTL',rsrcHttRspMsg,0));
 if(hHttpRspMsg==0)
  return;
 msgStt|=8;
 pMsg=MemHandleLock(hHttpRspMsg);
 msgStt|=16;
 for(crdNo=0;crdNo<4;crdNo++){
  if(*((Char *)((UInt32)pMsg+(UInt32)crdNo))!=verErrMsg[crdNo])
   msgStt&=239;
 }
 MemHandleUnlock(hHttpRspMsg);
 if((msgStt&16)==0)
  return;
 cmdErr&=251;
}

 void msgClose(void){

 if((msgStt&8)!=0){
  DmReleaseResource(hHttpRspMsg);
  msgStt&=247;
 }
 if((msgStt&2)!=0){
  DmReleaseResource(hErrMsg);
  msgStt&=253;
 }
 if((msgStt&1)!=0){
  DmCloseDatabase(dbErrMsg);
  msgStt&=254;
 }
}
//error manager
 void errBufferAlloc(void){
 MemHandle bufHandle;

 cmdErr=0;
 bufHandle=MemHandleNew(sizeof(appErrBufferType));
 if(bufHandle!=0){
  errBufferStack=MemHandleLock(bufHandle);
  MemSet(errBufferStack,sizeof(appErrBufferType),NULL);
  errBufferStack->thisChunk=bufHandle;
  cmdErr=1;
  errBufferStack->errPosFree=62;
 }
}

 void errBufferPreSet(UInt16 procID, UInt16 procCrtclStep, UInt32 typeOfErr){

 errBufferStack->bufferOfErrs[0].procID=procID;
 errBufferStack->bufferOfErrs[0].procCrtclStep=procCrtclStep;
 errBufferStack->bufferOfErrs[0].typeOfErr=typeOfErr;
 errBufferStack->bufferOfErrs[0].dwnldID=pSrcDst->brwsSlot;
 errBufferStack->bufferOfErrs[0].threadID=pSrcDst->brwsThread;
}

 void errBufferSetErr(Err errSet_0, Err errSet_1){

 if(errBufferStack->bufferOfErrs[0].numOfErrs!=8&&errSet_0!=0){
  errBufferStack->bufferOfErrs[0].arryOfErrs[errBufferStack->bufferOfErrs[0].numOfErrs]=errSet_0;
  errBufferStack->bufferOfErrs[0].numOfErrs++;
 }
 if(errBufferStack->bufferOfErrs[0].numOfErrs!=8&&errSet_1!=0){
  errBufferStack->bufferOfErrs[0].arryOfErrs[errBufferStack->bufferOfErrs[0].numOfErrs]=errSet_1;
  errBufferStack->bufferOfErrs[0].numOfErrs++;
 }
}

 void errBufferSetParam(UInt8 paramType, UInt32 param_0, UInt32 param_1, UInt32 param_2, UInt32 param_3){

 errBufferStack->bufferOfErrs[0].paramType=paramType;
 switch (paramType){
  case paramTypeMemAllocs:
   errBufferStack->bufferOfErrs[0].vars4Err.paramsMemAlloc.chnkSizeNeeded=param_0;
   errBufferStack->bufferOfErrs[0].vars4Err.paramsMemAlloc.toSetH=(MemHandle)param_1;
   errBufferStack->bufferOfErrs[0].vars4Err.paramsMemAlloc.toSetP=(MemPtr)param_2;
   break;
  case paramTypeMemOper:
   errBufferStack->bufferOfErrs[0].vars4Err.paramsMemOper.uniqueID=param_0;
   errBufferStack->bufferOfErrs[0].vars4Err.paramsMemOper.typeOfChnk=param_1;
   break;
  case paramTypeFlsOper:
   errBufferStack->bufferOfErrs[0].vars4Err.paramsFlsOper.param_0=param_0;
   errBufferStack->bufferOfErrs[0].vars4Err.paramsFlsOper.param_1=param_1;
   break;
  case paramTypeHttpRsp:
   errBufferStack->bufferOfErrs[0].vars4Err.paramsHttpAnswer.rspCode=param_0;
   break;
 }
}

 UInt8 errBufferCreateErrMsg(MemPtr msgPtr, appErrPtr errUse){
 UInt8 pInc=0;
 MemPtr pMsg=0;UInt16 httpRspCode;

 MemMove(msgPtr,"Info :: ",8);
 pInc=8;
 pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
 pInc+=getStrFromList(errUse->arryOfErrs[0],pMsg, hErrMsg);
 pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
 MemSet(pMsg,1,0x0A);
 pInc++;
 pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
 switch(errUse->paramType){
  case 0:
   MemMove(pMsg,"ID: 0x",6);
   pInc+=6;
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   pInc+=int2StrBase(errUse->procID,pMsg,16);
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   MemSet(pMsg,1,cComAt);
   pInc++;
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   MemMove(pMsg,"Step: 0x",8);
   pInc+=8;
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   pInc+=int2StrBase(errUse->procCrtclStep,pMsg,16);
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   MemSet(pMsg,1,0x0A);
   pInc++;
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   MemMove(pMsg,"Err0: 0x",8);
   pInc+=8;
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   pInc+=int2StrBase(errUse->arryOfErrs[1],pMsg,16);
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   MemSet(pMsg,1,cComAt);
   pInc++;
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   MemMove(pMsg,"Err1: 0x",8);
   pInc+=8;
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   pInc+=int2StrBase(errUse->arryOfErrs[2],pMsg,16);
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   MemSet(pMsg,1,0x0A);
   pInc++;
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   MemMove(pMsg,"Err2: 0x",8);
   pInc+=8;
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   pInc+=int2StrBase(errUse->arryOfErrs[3],pMsg,16);
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   MemSet(pMsg,1,cComAt);
   pInc++;
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   MemMove(pMsg,"Err3: 0x",8);
   pInc+=8;
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   pInc+=int2StrBase(errUse->arryOfErrs[4],pMsg,16);
   break;
  case paramTypeHttpRsp:
   httpRspCode=errUse->vars4Err.paramsHttpAnswer.rspCode;
   if(httpRspCode>499)
    httpRspCode=httpRspCode-500+rsrcHttpMsg500;
   else{
    if(httpRspCode>399)
     httpRspCode=httpRspCode-400+rsrcHttpMsg400;
    else{
     if(httpRspCode>299)
      httpRspCode=httpRspCode-300+rsrcHttpMsg300;
    }
   }
   MemMove(pMsg, "Server :: ",10);
   pInc+=10;
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   pInc+=getStrFromList(httpRspCode,pMsg, hHttpRspMsg);
   break;
  case paramTypeFlsOper:
   MemMove(pMsg,"ID: 0x",6);
   pInc+=6;
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   pInc+=int2StrBase(errUse->procID,pMsg,16);
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   MemSet(pMsg,1,cComAt);
   pInc++;
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   MemMove(pMsg,"Step: 0x",8);
   pInc+=8;
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   pInc+=int2StrBase(errUse->procCrtclStep,pMsg,16);
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   MemSet(pMsg,1,0x0A);
   pInc++;
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   MemMove(pMsg,"Prm0: 0x",8);
   pInc+=8;
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   pInc+=int2StrBase(errUse->vars4Err.paramsFlsOper.param_0,pMsg,16);
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   MemSet(pMsg,1,cComAt);
   pInc++;
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   MemMove(pMsg,"Prm1: 0x",8);
   pInc+=8;
   pMsg=(MemPtr)((UInt32)(msgPtr)+(UInt32)pInc);
   pInc+=int2StrBase(errUse->vars4Err.paramsFlsOper.param_1,pMsg,16);
   pInc++;
   break;
  default:
   break;
 }
 return pInc;
}

 UInt8 errBufferSetErrMsgLast(MemPtr msgPtr){
 UInt8 cInc;Boolean foundIndx=false;

 cInc=errBufferStack->errPosFree;
 if(cInc==62)
  return 0;
 do{
  if(((errBufferStack->bufferOfErrs[cInc].dwnldID)==pSrcDst->visSlot)/*&&((errBufferStack->bufferOfErrs[cInc].threadID)==pSrcDst->brwsThread)*/)
   foundIndx=true;
  else
   cInc++;
 }while(cInc!=63&&(!foundIndx));
 if(foundIndx){
//  prntInt(errBufferStack->bufferOfErrs[cInc].procID,70);
//  prntInt(errBufferStack->bufferOfErrs[cInc].procCrtclStep,80);
//  prntInt(errBufferStack->bufferOfErrs[cInc].numOfErrs,90);
  return errBufferCreateErrMsg(msgPtr,(MemPtr)((UInt32)(errBufferStack->bufferOfErrs)+(UInt32)(sizeof(appErrType)*cInc)));;
 }
 return 0;
}

 void errBufferInternalErr(UInt16 procID, UInt16 procCrtclStep, UInt32 typeOfErr, Err internalErr){

 errBufferStack->bufferOfErrs[63].procID=procID;
 errBufferStack->bufferOfErrs[63].procCrtclStep=procCrtclStep;
 errBufferStack->bufferOfErrs[63].typeOfErr=typeOfErr;
 errBufferStack->bufferOfErrs[63].arryOfErrs[0]=internalErr;
}

 void errBufferFreeError(UInt8 indx){

 if(errBufferStack->bufferOfErrs[indx].procID!=0)
 MemSet((MemPtr)((UInt32)(errBufferStack->bufferOfErrs)
  +(UInt32)(indx*sizeof(appErrType))),sizeof(appErrType),NULL);
}

 void errBufferPush(void){

 if(errBufferStack->errPosFree!=0){
  errBufferStack->bufferOfErrs[errBufferStack->errPosFree]=errBufferStack->bufferOfErrs[0];
  errBufferFreeError(0);
  errBufferStack->errPosFree--;
 }else
  errBufferInternalErr(iderrBufferPush,1,errTypeOfErrAlgoritm|errTypeOfErrWarning,errBufferIsFull);
}

 void errBufferPop(void){

 if(errBufferStack->errPosFree!=62){
  errBufferStack->errPosFree++;
  errBufferStack->bufferOfErrs[0]=errBufferStack->bufferOfErrs[errBufferStack->errPosFree];
  errBufferFreeError(errBufferStack->errPosFree);
 }else
  errBufferInternalErr(iderrBufferPop,1,errTypeOfErrAlgoritm|errTypeOfErrWarning,errBufferIsFree);
}

 void errBufferLogAll(void){
 Boolean rspOK=true;//dummy
 if(errBufferStack->errPosFree!=62){
  do{
   errBufferPop();
   rspOK=false;//log all errors to db(pdbDOC)
  }while(errBufferStack->errPosFree!=62);
 }
}

//void errBufferErrPublish(void){

//}

 void errBufferFree(void){
 MemHandle bufHandle;

 bufHandle=errBufferStack->thisChunk;
 fsErrApp=MemHandleUnlock(bufHandle);
 fsErrApp=MemHandleFree(bufHandle);
}

//memory handling
 void cstmMemoryInfoGet(UInt32 *sizeFree, UInt32 *sizeChnkFree, UInt32 *totalSize){
 UInt32 lszFree,lszChnkFree;

 fsErrApp=MemHeapFreeBytes(heapIDDynamic,&lszFree,&lszChnkFree);
 if(sizeFree!=0)
  *sizeFree=lszFree;
 if(sizeChnkFree!=0)
  *sizeChnkFree=lszChnkFree;
 if(totalSize!=0)
 *totalSize=MemHeapSize(heapIDDynamic);
}

 void cstmMemoryInit(void){//#2
 UInt32 totalSize;

 cstmMemTableDman.numOfChnkDataAlloc=maxHandledMemoryChunks;
 totalSize=maxHandledMemoryChunks*sizeOfChnkDataType;
 cstmMemTableDman.chnkDataHandle=MemHandleNew(totalSize);//#1
 if(cstmMemTableDman.chnkDataHandle!=0){
  cstmMemTableDman.chnkDataLocked=MemHandleLock(cstmMemTableDman.chnkDataHandle);//#2
  MemSet(cstmMemTableDman.chnkDataLocked,totalSize,NULL);
  cstmMemTableDman.chnkDataLocked->uniqueID=1;
  cstmMemTableDman.chnkDataLocked->procID=idcstmMemoryInit;
  cstmMemTableDman.chnkDataLocked->procCrtclStep=2;
  cstmMemTableDman.chnkDataLocked->typeOfChnk=cstmMemTypeOfChnkHandleLocked|cstmMemTypeOfChnkCritical|cstmMemTypeOfChnkNONUpdatable;
  cstmMemTableDman.chnkDataLocked->newHandleConst=cstmMemTableDman.chnkDataHandle;
  cstmMemTableDman.chnkDataLocked->newPtrConst=cstmMemTableDman.chnkDataLocked;
  cstmMemTableDman.chnkDataLocked->sizeInUse=totalSize;
  cstmMemTableDman.nextUniqueID=2;
  cstmMemTableDman.uniqueIDHigh=0;
  cstmMemTableDman.nextChnkFree=1;
  cstmMemTableDman.chnksAllocated=1;
 }else cmdErr|=2;
}


 void cstmMemoryReformatChnks(void){
 chnkDataPtr moveTo=0,moveFrom;Char zeroGot=0;
 UInt32 nxtFree=0;

 while(nxtFree<(cstmMemTableDman.numOfChnkDataAlloc)){
  moveFrom=(MemPtr)((UInt32)cstmMemTableDman.chnkDataLocked+(UInt32)(sizeOfChnkDataType*nxtFree));
  if(moveFrom->uniqueID==0){
   if(moveTo==0){
    if(zeroGot==0){
     cstmMemTableDman.nextChnkFree=nxtFree;
     zeroGot++;
    }
    moveTo=(MemPtr)((UInt32)cstmMemTableDman.chnkDataLocked+(UInt32)(sizeOfChnkDataType*nxtFree));
   }
  }else{
   if(moveTo!=0){
    MemMove(moveTo,moveFrom,sizeOfChnkDataType);
    moveFrom->uniqueID=0;
    if(zeroGot==1){
     cstmMemTableDman.nextChnkFree=nxtFree;
    }
    if((moveFrom->typeOfChnk&5)==cstmMemTypeOfChnkHandleLocked)
     moveTo->typeOfChnk|=cstmMemTypeOfChnkSecureUpdate;
    moveTo=moveFrom;
   }
  }
  nxtFree++;
 }
}

//void cstmMemoryGetFreeID(void){
//UInt32 lowID=1,nxtChnk;
// if((cstmMemTableDman.uniqueIDHigh==0)&&(cstmMemTableDman.chnksAllocated>1)){
//  cstmMemTableDman.uniqueIDHigh=cstmMemTableDman.nextUniqueID;
//  cstmMemTableDman.chnkDataRelative=cstmMemTableDman.chnkDataLocked;
//  while(lowID!=0){
//   nxtChnk++;
//   cstmMemTableDman.chnkDataRelative+=sizeOfChnkDataType;
//   if(cstmMemTableDman.chnkDataRelative->uniqueID!=0){
//    if((cstmMemTableDman.chnkDataRelative->uniqueID<cstmMemTableDman.nextUniqueID)&&(cstmMemTableDman.chnkDataRelative->uniqueID>lowID)){
//     if(cstmMemTableDman.chnkDataRelative->uniqueID>(lowID+1))
//      cstmMemTableDman.nextUniqueID=cstmMemTableDman.chnkDataRelative->uniqueID;//???
//      else lowID=cstmMemTableDman.chnkDataRelative->uniqueID;}
//    }
//    else{
//     if(lowID<)
//     lowID=0;
//     }
//   }}
//}

 Boolean cstmMemoryGet(UInt8 typeOfChnk, UInt32 sizeChnk, UInt16 procID, UInt16 procCrtclStep){
 Boolean rspOK=false;

 if(cstmMemTableDman.numOfChnkDataAlloc==cstmMemTableDman.chnksAllocated){
  errBufferPreSet(procID,procCrtclStep,errTypeOfErrMemory|(typeOfChnk&cstmMemTypeOfChnkCritical));
  errBufferSetErr(errMemManTableFull,0);
  errBufferSetParam(paramTypeMemAllocs,sizeChnk,0,0,0);
  errBufferPush();
  return rspOK;
 }
 cstmMemTableDman.chnkDataRelative=(MemPtr)((UInt32)cstmMemTableDman.chnkDataLocked
  +(UInt32)(sizeOfChnkDataType*cstmMemTableDman.nextChnkFree));
 if(cstmMemTableDman.nextChnkFree<(cstmMemTableDman.numOfChnkDataAlloc-1))
  cstmMemTableDman.nextChnkFree++;
 else{
  cstmMemTableDman.nextChnkFree=0;
  cstmMemoryReformatChnks();
 }
 MemSet(cstmMemTableDman.chnkDataRelative,sizeOfChnkDataType,NULL);
 cstmMemTableDman.chnkDataRelative->typeOfChnk=typeOfChnk;
 cstmMemTableDman.chnkDataRelative->procID=procID;
 cstmMemTableDman.chnkDataRelative->procCrtclStep=procCrtclStep;
 cstmMemTableDman.chnkDataRelative->sizeInUse=sizeChnk;
 switch(typeOfChnk&cstmMemTypeOfChnkAll){
  case cstmMemTypeOfChnkHandle:
   cstmMemTableDman.chnkDataRelative->newHandleConst=MemHandleNew(sizeChnk);
   if(cstmMemTableDman.chnkDataRelative->newHandleConst!=0){
    rspOK=true;
    if((typeOfChnk&cstmMemTypeOfChnkLocked)==cstmMemTypeOfChnkLocked){
     cstmMemTableDman.chnkDataRelative->newPtrConst=MemHandleLock(cstmMemTableDman.chnkDataRelative->newHandleConst);
     cstmMemTableDman.chnkDataRelative->lockCounter++;
    }
   }
   break;
 case cstmMemTypeOfChnkPtr:
  cstmMemTableDman.chnkDataRelative->newPtrConst=MemPtrNew(sizeChnk);
  if(cstmMemTableDman.chnkDataRelative->newPtrConst!=0){
   rspOK=true;
  }
  break;
 }
 if(rspOK){
  cstmMemTableDman.chnkDataRelative->uniqueID=cstmMemTableDman.nextUniqueID;
  cstmMemTableDman.nextUniqueID++;//!!!!search for unused?
  cstmMemTableDman.chnksAllocated++;
 }else{
  errBufferPreSet(procID,procCrtclStep,errTypeOfErrMemory|(typeOfChnk&cstmMemTypeOfChnkCritical));
  errBufferSetErr(errMemManAllocFailed,0);
  errBufferSetParam(paramTypeMemAllocs,sizeChnk,0,0,0);
  errBufferPush();
  if(cstmMemoryRecoverer(sizeChnk)){
   switch(typeOfChnk&cstmMemTypeOfChnkAll){
    case cstmMemTypeOfChnkHandle:
     cstmMemTableDman.chnkDataRelative->newHandleConst=MemHandleNew(sizeChnk);
     if(cstmMemTableDman.chnkDataRelative->newHandleConst!=0){
      rspOK=true;
      if((typeOfChnk&cstmMemTypeOfChnkLocked)==cstmMemTypeOfChnkLocked){
       cstmMemTableDman.chnkDataRelative->newPtrConst=MemHandleLock(cstmMemTableDman.chnkDataRelative->newHandleConst);
       cstmMemTableDman.chnkDataRelative->lockCounter++;
      }
     }
     break;
    case cstmMemTypeOfChnkPtr:
     cstmMemTableDman.chnkDataRelative->newPtrConst=MemPtrNew(sizeChnk);
     if(cstmMemTableDman.chnkDataRelative->newPtrConst!=0){
      rspOK=true;
     }
     break;
   }
   if(rspOK){
    cstmMemTableDman.chnkDataRelative->uniqueID=cstmMemTableDman.nextUniqueID;
    cstmMemTableDman.nextUniqueID++;//!!!!search for unused?
    cstmMemTableDman.chnksAllocated++;
    errBufferPreSet(procID,procCrtclStep,errTypeOfErrRecovered|errTypeOfErrMemory);
    errBufferPush();
   }else{
    errBufferPreSet(procID,procCrtclStep,errTypeOfErrMemory|(typeOfChnk&cstmMemTypeOfChnkCritical));
    errBufferSetErr(errMemManRecoveryFailed,0);
    errBufferSetParam(paramTypeMemAllocs,sizeChnk,0,0,0);
    errBufferPush();
   }
  }
 }
 return rspOK;
}

 void cstmMemoryGetPtrFromID(UInt32 uniqueID){
 UInt32 chnksPos=0;
 
 for(chnksPos=0;chnksPos<(cstmMemTableDman.numOfChnkDataAlloc);chnksPos++){
  cstmMemTableDman.chnkDataRelative=(MemPtr)((UInt32)cstmMemTableDman.chnkDataLocked
   +(UInt32)(sizeOfChnkDataType*chnksPos));
  if(cstmMemTableDman.chnkDataRelative->uniqueID==uniqueID)
   break;
  else{
   cstmMemTableDman.chnkDataRelative=0;
  }
 }
 if(cstmMemTableDman.chnkDataRelative==0){
  errBufferPreSet(idcstmMemoryGetPtrFromID,1,errTypeOfErrWarning);
  errBufferSetErr(errMemManIDNotExist,0);
  errBufferSetParam(paramTypeMemOper,uniqueID,0,0,0);
  errBufferPush();
 }
}

MemHandle cstmMemoryGetHFromID(UInt32 uniqueID){

 cstmMemoryGetPtrFromID(uniqueID);
 if(cstmMemTableDman.chnkDataRelative!=0){
  if((cstmMemTableDman.chnkDataRelative->typeOfChnk&cstmMemTypeOfChnkHandle)!=0){
   return cstmMemTableDman.chnkDataRelative->newHandleConst;
  }else{
   errBufferPreSet(idcstmMemoryGetHFromID,1,errTypeOfErrWarning);
   errBufferSetErr(errMemManNotHandleType,0);
   errBufferSetParam(paramTypeMemOper,uniqueID,0,0,0);
   errBufferPush();
  }
 }
 return 0;
}

//void cstmMemoryPtrAdjust(MemPtr baseNewPtr,MemPtr baseOldPtr, MemPtr *pAdjust){
//
// *pAdjust=(MemPtr)((UInt32)baseNewPtr+((UInt32)(*pAdjust)-(UInt32)baseOldPtr));
//}

void cstmMemorySetUpdatable(UInt32 uniqueID,Boolean set2Update){
 cstmMemoryGetPtrFromID(uniqueID);
 if(cstmMemTableDman.chnkDataRelative!=0){
  if(set2Update)
   cstmMemTableDman.chnkDataRelative->typeOfChnk&=(255-cstmMemTypeOfChnkNONUpdatable);
  else cstmMemTableDman.chnkDataRelative->typeOfChnk|=cstmMemTypeOfChnkNONUpdatable;
 }
}

void cstmMemoryRmNeedsUpdate(UInt32 uniqueID){
 cstmMemoryGetPtrFromID(uniqueID);
 if(cstmMemTableDman.chnkDataRelative!=0){
   cstmMemTableDman.chnkDataRelative->typeOfChnk&=(255-cstmMemTypeOfChnkNeedsUpdate);
   cstmMemTableDman.chnkDataRelative->oldPtrConst=0;
 }
}

MemPtr cstmMemoryChnkLock(UInt32 uniqueID, UInt16 procID, UInt16 procCrtclStep){
MemPtr lockedPtr;

 cstmMemoryGetPtrFromID(uniqueID);
 if(cstmMemTableDman.chnkDataRelative!=0){
  if((cstmMemTableDman.chnkDataRelative->typeOfChnk&cstmMemTypeOfChnkHandle)==cstmMemTypeOfChnkHandle){
   if((cstmMemTableDman.chnkDataRelative->lockCounter)==0){
    cstmMemTableDman.chnkDataRelative->newPtrConst=MemHandleLock(cstmMemTableDman.chnkDataRelative->newHandleConst);
    cstmMemTableDman.chnkDataRelative->typeOfChnk|=cstmMemTypeOfChnkLocked;
   }
   lockedPtr=cstmMemTableDman.chnkDataRelative->newPtrConst;
   cstmMemTableDman.chnkDataRelative->lockCounter++;//overlocking!!!handle later
  }else{
   lockedPtr=0;
   errBufferPreSet(procID,procCrtclStep,errTypeOfErrWarning);
   errBufferSetErr(errMemManIncorrectTypeLock,0);
   errBufferSetParam(paramTypeMemOper,uniqueID,0,0,0);
   errBufferPush();
  }
 }else lockedPtr=0;
return lockedPtr;
}

void cstmMemoryChnkUnlock(UInt32 uniqueID, UInt16 procID, UInt16 procCrtclStep){

 cstmMemoryGetPtrFromID(uniqueID);
 if(cstmMemTableDman.chnkDataRelative!=0){
  if((cstmMemTableDman.chnkDataRelative->typeOfChnk&cstmMemTypeOfChnkHandleLocked)==cstmMemTypeOfChnkHandleLocked){
   cstmMemTableDman.chnkDataRelative->lockCounter--;
   if(cstmMemTableDman.chnkDataRelative->lockCounter==0){
    fsErrApp=MemHandleUnlock(cstmMemTableDman.chnkDataRelative->newHandleConst);
    cstmMemTableDman.chnkDataRelative->typeOfChnk^=cstmMemTypeOfChnkLocked;
    if((cstmMemTableDman.chnkDataRelative->typeOfChnk&cstmMemTypeOfChnkNONUpdatable)!=cstmMemTypeOfChnkNONUpdatable){
     cstmMemTableDman.chnkDataRelative->typeOfChnk|=cstmMemTypeOfChnkNeedsUpdate;
     cstmMemTableDman.chnkDataRelative->oldPtrConst=cstmMemTableDman.chnkDataRelative->newPtrConst;
     cstmMemTableDman.chnkDataRelative->sizeOld=cstmMemTableDman.chnkDataRelative->sizeInUse;
    }
    cstmMemTableDman.chnkDataRelative->newPtrConst=0;
   }//underlocking!!!handle later
  }else{
   errBufferPreSet(procID,procCrtclStep,errTypeOfErrWarning);
   errBufferSetErr(errMemManIncorrectTypeUnlock,0);
   errBufferSetParam(paramTypeMemOper,uniqueID,0,0,0);
   errBufferPush();
  }
 }
}

void cstmMemoryChnkUnlockAll(void){
  UInt32 chnksPos=1;
 
 while(chnksPos<(cstmMemTableDman.numOfChnkDataAlloc)){
  cstmMemTableDman.chnkDataRelative=(MemPtr)((UInt32)cstmMemTableDman.chnkDataLocked
   +(UInt32)(sizeOfChnkDataType*chnksPos));
  if(cstmMemTableDman.chnkDataRelative->uniqueID!=0)
   if((cstmMemTableDman.chnkDataRelative->typeOfChnk&(cstmMemTypeOfChnkHandleLocked
    |cstmMemTypeOfChnkNONUpdatable))==cstmMemTypeOfChnkHandleLocked){
     cstmMemTableDman.chnkDataRelative->typeOfChnk|=(cstmMemTypeOfChnkNeedsUpdate|cstmMemTypeOfChnkSecureUpdate);
     cstmMemTableDman.chnkDataRelative->oldPtrConst=cstmMemTableDman.chnkDataRelative->newPtrConst;
     fsErrApp=MemHandleUnlock(cstmMemTableDman.chnkDataRelative->newHandleConst);
     cstmMemTableDman.chnkDataRelative->newPtrConst=0;
   }
  chnksPos++;
 }
}

void cstmMemoryChnkLockAll(void){
 UInt32 chnksPos=1;
 
 while(chnksPos<(cstmMemTableDman.numOfChnkDataAlloc)){
  cstmMemTableDman.chnkDataRelative=(MemPtr)((UInt32)cstmMemTableDman.chnkDataLocked
   +(UInt32)(sizeOfChnkDataType*chnksPos));
  if(cstmMemTableDman.chnkDataRelative->uniqueID!=0)
   if((cstmMemTableDman.chnkDataRelative->typeOfChnk&(cstmMemTypeOfChnkHandleLocked
    |cstmMemTypeOfChnkSecureUpdate))==(cstmMemTypeOfChnkHandleLocked|cstmMemTypeOfChnkSecureUpdate)){
     cstmMemTableDman.chnkDataRelative->typeOfChnk&=(255-cstmMemTypeOfChnkSecureUpdate);
     cstmMemTableDman.chnkDataRelative->newPtrConst=MemHandleLock(cstmMemTableDman.chnkDataRelative->newHandleConst);
   }
  chnksPos++;
 }
}

Boolean cstmMemoryRecoverer(UInt32 neededSize){
UInt32 memChnkLargestFree;Boolean rspOK=false;

 cstmMemoryChnkUnlockAll();
 fsErrApp=MemHandleUnlock(cstmMemTableDman.chnkDataHandle);
 fsErrApp=MemHeapCompact(heapIDDynamic);
 cstmMemoryInfoGet(0,&memChnkLargestFree,0);
 if(memChnkLargestFree<neededSize){
  fsErrApp=MemHeapCompact(heapIDDynamic);
  cstmMemoryInfoGet(0,&memChnkLargestFree,0);
  if(memChnkLargestFree>=neededSize)
   rspOK=true;
 }else
  rspOK=true;
 cstmMemTableDman.chnkDataLocked=MemHandleLock(cstmMemTableDman.chnkDataHandle);
 cstmMemTableDman.chnkDataLocked->newPtrConst=cstmMemTableDman.chnkDataLocked;
 cstmMemoryChnkLockAll();
 return rspOK;
}

Boolean cstmMemoryUpdatePtrRange(UInt32 uniqueID, MemPtr *p2Update){
Boolean rspOK=true;UInt32 offst4Ptr;

 cstmMemoryGetPtrFromID(uniqueID);
 if(cstmMemTableDman.chnkDataRelative!=0){
  if((cstmMemTableDman.chnkDataRelative->typeOfChnk&cstmMemTypeOfChnkNONUpdatable)==0){
   if((cstmMemTableDman.chnkDataRelative->typeOfChnk&cstmMemTypeOfChnkNeedsUpdate)!=0){
    if((*p2Update)!=0&&(*p2Update>=cstmMemTableDman.chnkDataRelative->oldPtrConst)){
     offst4Ptr=(*((UInt32*)p2Update)-(UInt32)(cstmMemTableDman.chnkDataRelative->oldPtrConst));
     if(offst4Ptr<(cstmMemTableDman.chnkDataRelative->sizeOld)){
      *p2Update=(MemPtr)((UInt32)(cstmMemTableDman.chnkDataRelative->newPtrConst)+offst4Ptr);
     }else{
      *p2Update=cstmMemTableDman.chnkDataRelative->newPtrConst;
      errBufferPreSet(cstmMemTableDman.chnkDataRelative->procID,cstmMemTableDman.chnkDataRelative->procCrtclStep,errTypeOfErrWarning);
      errBufferSetErr(errMemManPtrRangeIncorrect,0);
      errBufferSetParam(paramTypeMemOper,uniqueID,cstmMemTableDman.chnkDataRelative->typeOfChnk,0,0);
      errBufferPush();
     }
    }else{
     errBufferPreSet(cstmMemTableDman.chnkDataRelative->procID,cstmMemTableDman.chnkDataRelative->procCrtclStep,errTypeOfErrAlgoritm|errTypeOfErrCritical);
     errBufferSetErr(errMemManPtrInvalid,0);
     errBufferSetParam(paramTypeMemOper,uniqueID,cstmMemTableDman.chnkDataRelative->typeOfChnk,0,0);
     errBufferPush();
    }
   }else
    *p2Update=cstmMemTableDman.chnkDataRelative->newPtrConst;
  }else{
   rspOK=false;
   errBufferPreSet(cstmMemTableDman.chnkDataRelative->procID,cstmMemTableDman.chnkDataRelative->procCrtclStep,errTypeOfErrWarning);
   errBufferSetErr(errMemManNONUpdatableAccessed,0);
   errBufferSetParam(paramTypeMemOper,uniqueID,cstmMemTableDman.chnkDataRelative->typeOfChnk,0,0);
   errBufferPush();
  }
 }else rspOK=false;
 return rspOK;
}

Boolean cstmMemoryUpdatePtr(UInt32 uniqueID, MemPtr *p2Update){
Boolean rspOK=false;

 cstmMemoryGetPtrFromID(uniqueID);
 if(cstmMemTableDman.chnkDataRelative!=0){
  if((cstmMemTableDman.chnkDataRelative->typeOfChnk&cstmMemTypeOfChnkNONUpdatable)==0){
   *p2Update=cstmMemTableDman.chnkDataRelative->newPtrConst;
   rspOK=true;
  }else{
   errBufferPreSet(cstmMemTableDman.chnkDataRelative->procID,cstmMemTableDman.chnkDataRelative->procCrtclStep,errTypeOfErrWarning);
   errBufferSetErr(errMemManNONUpdatableAccessed,0);
   errBufferSetParam(paramTypeMemOper,uniqueID,cstmMemTableDman.chnkDataRelative->typeOfChnk,0,0);
   errBufferPush();
  }
 }
 return rspOK;
}

 void cstmMemoryDrop(UInt32 uniqueID){

 cstmMemoryGetPtrFromID(uniqueID);
 if(cstmMemTableDman.chnkDataRelative!=0){
  if((cstmMemTableDman.chnkDataRelative->typeOfChnk&cstmMemTypeOfChnkNONUpdatable)==0){
   switch(cstmMemTableDman.chnkDataRelative->typeOfChnk&cstmMemTypeOfChnkAll){
    case cstmMemTypeOfChnkHandle:
     if((cstmMemTableDman.chnkDataRelative->typeOfChnk&cstmMemTypeOfChnkHandleLocked)==cstmMemTypeOfChnkHandleLocked){
      fsErrApp=MemHandleUnlock(cstmMemTableDman.chnkDataRelative->newHandleConst);
      cstmMemTableDman.chnkDataRelative->lockCounter--;
     }
     fsErrApp=MemHandleFree(cstmMemTableDman.chnkDataRelative->newHandleConst);//???vrf?
     cstmMemTableDman.chnkDataRelative->typeOfChnk=0;//???
     cstmMemTableDman.chnkDataRelative->uniqueID=0;
     cstmMemTableDman.chnksAllocated--;
     break;
    case cstmMemTypeOfChnkPtr:
     MemPtrFree(cstmMemTableDman.chnkDataRelative->newPtrConst);
     cstmMemTableDman.chnkDataRelative->typeOfChnk=0;//???
     cstmMemTableDman.chnkDataRelative->uniqueID=0;
     cstmMemTableDman.chnksAllocated--;
     break;
   }
   if(cstmMemTableDman.chnkDataRelative->uniqueID==0){
    MemSet((cstmMemTableDman.chnkDataRelative),sizeOfChnkDataType,NULL);
    cstmMemTableDman.chnkDataRelative=0;
   }
  }else{
   errBufferPreSet(cstmMemTableDman.chnkDataRelative->procID,cstmMemTableDman.chnkDataRelative->procCrtclStep,errTypeOfErrWarning);
   errBufferSetErr(errMemManNONUpdatableAccessed,0);
   errBufferSetParam(paramTypeMemOper,uniqueID,cstmMemTableDman.chnkDataRelative->typeOfChnk,0,0);
   errBufferPush();
  }
 }
}

void cstmMemoryClose(void){
 if((cmdErr&64)==0){
  cstmMemoryReformatChnks();
 cstmMemTableDman.chnkDataRelative=(MemPtr)((UInt32)cstmMemTableDman.chnkDataLocked
   +(UInt32)(sizeOfChnkDataType*1));
/* prntInt(cstmMemTableDman.chnkDataRelative->procID,20);
 prntInt(cstmMemTableDman.chnkDataRelative->procCrtclStep,30);
 prntInt(cstmMemTableDman.chnksAllocated,40);
 SysTaskDelay(500);*/

//!!!!!!!!! free all chunks and publish as unfreed
  fsErrApp=MemHandleUnlock(cstmMemTableDman.chnkDataHandle);
  fsErrApp=MemHandleFree(cstmMemTableDman.chnkDataHandle);
 }
}

// UInt16 memMover(MemPtr moveTo,MemPtr moveFrom,UInt16 lenMove){
// UInt16 partMove,partLeft,pInc=0;MemPtr bufExch;
// 
// if(lenMove>0){
//  partLeft=lenMove;
//  bufExch=MemPtrNew(8192);
//  do{
//   if(partLeft>8191){
//    partMove=8192;
//    partLeft-=8192;
//   }else{
//    partMove=partLeft;
//    partLeft=0;
//   }
//   fsErrApp=MemMove(bufExch,(MemPtr)((UInt32)moveFrom+(UInt32)pInc),partMove);
//   fsErrApp=MemMove((MemPtr)((UInt32)moveTo+(UInt32)pInc),bufExch,partMove);
//   pInc+=8192;
//  }while(partLeft!=0);
//  MemPtrFree(bufExch);
// }
// return 0;
//}